<?php
/**
 * Created by PhpStorm.
 * User: zuffik
 * Date: 2.12.2017
 * Time: 10:20
 */

namespace Zuffik\Srvant\Generators\Random\Distributions;

/**
 * Class Distribution used for generating random number using some probability distribution function
 * @package Zuffik\Srvant\Generators\Random\Distributions
 */
abstract class Distribution
{

    /**
     * Returns next number using PDF
     * @return float
     */
    public abstract function nextFloat();

    /**
     * Default: returns rounded number generated by nextFloat
     * @return int
     */
    public function nextInt()
    {
        return round($this->nextFloat());
    }

    /**
     * Default: returns ascii character
     * @return string
     */
    public function nextChar()
    {
        return chr($this->nextInt());
    }

    /**
     * Integer iterator
     * @return \Generator|int[]
     */
    public function getIntegers()
    {
        yield $this->nextInt();
    }

    /**
     * Float iterator
     * @return \Generator|float[]
     */
    public function getFloats()
    {
        yield $this->nextFloat();
    }

    /**
     * Character iterator
     * @return \Generator|string
     */
    public function getCharacters()
    {
        yield $this->nextChar();
    }
}